#!/bin/bash

if [[ $# -ne 3 ]]; then
  echo "usage: bootstrap-node.sh <ssh-key> <ddns-key> <interface>"
  exit 1;
fi

ssh_key=$1
ddns_key=$2
ifx=$3
me=`hostname`

dnf install -y bind-utils

mkdir -p /root/.ssh
cat $ssh_key >> /root/.ssh/authorized_keys

mkdir -p /opt/merge
cp ddns-key /opt/merge

ip link set up $ifx
dhclient -r $ifx
dhclient $ifx

myip=`ip -o -4 addr show dev $ifx | cut -d ' ' -f 7 | cut -f 1 -d '/'`
raddr=`echo $myip | awk -F. '{print $4"."$3"."$2"."$1}'`

cat <<EOF > /tmp/nsdata
server ns0.portal.{{ domain }}
zone portal.{{ domain }}

update delete $me.portal.{{ domain }}. A
update add $me.portal.{{ domain }}. 86400 A $myip

zone {{ (proxy.internal.network | ipaddr('revdns'))[2:-1] }}
update delete $raddr.in-addr.arpa. PTR
update add $raddr.in-addr.arpa. 86400 PTR $me.portal.{{ domain }}.

show
send
EOF

nsupdate -k /opt/merge/ddns-key /tmp/nsdata
